<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="80px">
      <el-form-item label="现场评审编号" prop="scenReviCode">
        <el-input v-model="queryParams.scenReviCode" placeholder="请输入现场评审编号" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="Plus" @click="handleAdd" v-hasPermi="['stan:scenrevi:add']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="success" plain icon="Edit" :disabled="single" @click="handleUpdate" v-hasPermi="['stan:scenrevi:edit']">修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete" v-hasPermi="['stan:scenrevi:remove']">删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="Download" @click="handleExport" v-hasPermi="['stan:scenrevi:export']">导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList" :columns="columns" storageKey="stan-scenrevi-"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="dataList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="现场评审编号" prop="scenReviCode" />
      <el-table-column label="现场评审意见" prop="scenReviOpin" />
      <el-table-column label="验证意见" prop="veriOpin" />
      <el-table-column label="批准意见" prop="apprOpin" />
      <el-table-column label="操作" align="center" width="200">
        <template #default="scope">
          <el-tooltip content="修改" placement="top">
            <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['stan:scenrevi:edit']"></el-button>
          </el-tooltip>
          <el-tooltip content="删除" placement="top">
            <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['stan:scenrevi:remove']"></el-button>
          </el-tooltip>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total>0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize" @pagination="getList" />

    <el-dialog :title="title" v-model="open" width="650px" append-to-body>
      <el-form ref="formRef" :model="form" :rules="rules" label-width="110px">
        <el-form-item label="申请GUID" prop="applGuid">
          <el-input v-model="form.applGuid" placeholder="请输入申请GUID" />
        </el-form-item>
        <el-form-item label="现场评审编号" prop="scenReviCode">
          <el-input v-model="form.scenReviCode" placeholder="请输入现场评审编号" />
        </el-form-item>
        <el-form-item label="现场评审意见" prop="scenReviOpin">
          <el-input v-model="form.scenReviOpin" type="textarea" placeholder="请输入现场评审意见" />
        </el-form-item>
        <el-form-item label="验证意见" prop="veriOpin">
          <el-input v-model="form.veriOpin" type="textarea" placeholder="请输入验证意见" />
        </el-form-item>
        <el-form-item label="批准意见" prop="apprOpin">
          <el-input v-model="form.apprOpin" type="textarea" placeholder="请输入批准意见" />
        </el-form-item>
        <el-form-item label="批准状态" prop="apprStat">
          <el-input v-model="form.apprStat" placeholder="请输入批准状态" />
        </el-form-item>
        <el-form-item label="验证状态" prop="veriStat">
          <el-input v-model="form.veriStat" placeholder="请输入验证状态" />
        </el-form-item>
        <el-form-item label="备注" prop="note">
          <el-input v-model="form.note" type="textarea" placeholder="请输入备注" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="ScenRevi">
import { listBisScenRevi, getBisScenRevi, addBisScenRevi, updateBisScenRevi, delBisScenRevi } from "@/api/slaj/stan";
import { getCurrentInstance, reactive, ref, toRefs } from "vue";

const { proxy } = getCurrentInstance();

const dataList = ref([]);
const open = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const title = ref("");
const columns = ref({ scenReviCode: { visible: true }, scenReviOpin: { visible: true }, veriOpin: { visible: true }, apprOpin: { visible: true } });

const data = reactive({
  form: {},
  queryParams: { pageNum: 1, pageSize: 10, scenReviCode: null },
  rules: {}
});
const { form, queryParams, rules } = toRefs(data);

function getList() {
  loading.value = true;
  listBisScenRevi(queryParams.value).then(r => {
    dataList.value = r.rows;
    total.value = r.total;
    loading.value = false;
  });
}

function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

function resetQuery() {
  proxy.resetForm("queryRef");
  handleQuery();
}

function handleSelectionChange(s) {
  ids.value = s.map(i => i.guid);
  single.value = s.length !== 1;
  multiple.value = !s.length;
}

function handleAdd() {
  reset();
  open.value = true;
  title.value = "添加现场评审";
}

function handleUpdate(row) {
  reset();
  getBisScenRevi(row.guid || ids.value[0]).then(r => {
    form.value = r.data;
    open.value = true;
    title.value = "修改现场评审";
  });
}

function submitForm() {
  proxy.$refs["formRef"].validate(v => {
    if (v) {
      if (form.value.guid != null) {
        updateBisScenRevi(form.value).then(() => {
          proxy.$modal.msgSuccess("修改成功");
          open.value = false;
          getList();
        });
      } else {
        addBisScenRevi(form.value).then(() => {
          proxy.$modal.msgSuccess("新增成功");
          open.value = false;
          getList();
        });
      }
    }
  });
}

function handleDelete(row) {
  proxy.$modal.confirm('确认删除？').then(() => delBisScenRevi(row.guid || ids.value.join(","))).then(() => {
    getList();
    proxy.$modal.msgSuccess("删除成功");
  });
}

function handleExport() {
  proxy.download('/stan/scenrevi/export', { ...queryParams.value }, `现场评审_${new Date().getTime()}.xlsx`);
}

function cancel() {
  open.value = false;
  reset();
}

function reset() {
  form.value = { guid: null, applGuid: null, scenReviCode: null, scenReviOpin: null, veriOpin: null, apprOpin: null, apprStat: null, veriStat: null, note: null };
  proxy.resetForm("formRef");
}

getList();
</script>
